package com.futhark;

import java.util.HashMap;
import java.util.Map;

public enum RuneType {
    UNKNOWN(0),
    INCOMPLETE_TIER_0(1),
    INCOMPLETE_TIER_1(2),
    INCOMPLETE_TIER_2(3),
    TELEPORT_START(4),
    TELEPORT_END(5);

    private final int value;

    RuneType(int value) {
        this.value = value;
    }

    public int asInt() {
        return value;
    }

    private static final Map<Integer, RuneType> intToTypeMap = new HashMap<>();

    static {
        for (RuneType type : RuneType.values()) {
            intToTypeMap.put(type.value, type);
        }
    }

    public static RuneType fromInt(int value) {
        RuneType type = intToTypeMap.get(Integer.valueOf(value));
        if (type == null) {
            throw new IllegalArgumentException("Unknown value: " + value);
        }
        return type;
    }
}